'+--------------------------------------------------------------------------+
'|                               GLDrawDIB                                  |
'|                                                                          |
'|               Example of OpenGL drawing to a 32-bit DIB                  |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-04-2008 (MM-DD-YYYY)            |
'|                        Last revised : 10-04-2008 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "GLDrawDIB.exe"

#INCLUDE "GLDrawDIB.inc"

'------------------------------------------------------------------------------------------
' LOCAL section
'-----------------------------------------------------------------------------------------

%FRAME_SizeX = 256 '// The animation frame width
%FRAME_SizeY = 256 '// The animation frame height
%TIMER_DELAY = 20  '// The timer delay (animation speed)

GLOBAL gnCtrl, hGLDC, hGLRC, ghMemDC, ghBmp AS LONG
GLOBAL mt() AS BBPTEXTURE

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WNDCLASSEX
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS DWORD
'
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZAEROGL"
    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(GetModuleHandle(""), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0
       wc.hInstance     = GetModuleHandle("")
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

'   // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = %WS_EX_TOPMOST OR %WS_EX_TOOLWINDOW

     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %FRAME_SizeX, %FRAME_SizeY)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "AeroGL"
       hMain = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

'         // The OpenGL stuff
          CALL CreateGLcontext(rc.nRight - rc.nLeft, rc.nBottom - rc.nTop, hGLDC, hGLRC)
          DIM mt(1 TO 2) AS BBPTEXTURE
          mt(1).FullName = EXE.Path$ + "infrared.jpg": mt(1).ID = 1: mt(1).Square = 0
          'mt(1).FullName = EXE.Path$ + "LensFlare.png": mt(1).ID = 1: mt(1).Square = 0
          mt(2).FullName = EXE.Path$ + "ilaero.png":  mt(2).ID = 2: mt(2).Square = 0
          'mt(2).FullName = EXE.Path$ + "GLDrawDIB.jpg":  mt(2).ID = 2: mt(2).Square = 0

          CALL MakeMutipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)
          'CALL glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)

          CALL ShowWindow(hMain, %SW_SHOW)

          CALL SetTimer(hMain, 1, %TIMER_DELAY, %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
          WEND
          CALL KillTimer(hMain, 1)

          '//FreeUp resources
          IF ghBmp THEN
             CALL DeleteObject(ghBmp)
             CALL DeleteDC(ghMemDC)
          END IF
          CALL DestroyGLresources(hGLDC, hGLRC)

          FUNCTION = msg.wParam
       END IF

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

    SELECT CASE LONG Msg
        
    CASE %WM_KEYDOWN
         IF wParam = &H1B& THEN '// VK_ESCAPE
            CALL DestroyWindow(hWnd)
         END IF
         
    CASE %WM_TIMER
         CALL SetImage(hWnd)
         
    CASE %WM_NCHITTEST
         FUNCTION = %HTCAPTION: EXIT FUNCTION

    CASE %WM_DESTROY
         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB zAlphaBlend ALIAS "zAlphaBlend" (BYVAL hDcDest AS LONG, BYVAL xDest AS LONG, yDest AS LONG, BYVAL wDest AS LONG, BYVAL hDest AS LONG, BYVAL hDcSrce AS LONG, BYVAL xSrce AS LONG, BYVAL ySrce AS LONG, BYVAL wSrce AS LONG, BYVAL hSrce AS LONG) EXPORT

'   32-Bit Translucency BitBlt Function
    DIM bf AS BLENDFUNCTION    ' structure for alpha blending

    bf.BlendOp = %AC_SRC_OVER
    bf.BlendFlags = 0
    bf.AlphaFormat = %AC_SRC_ALPHA  ' use source alpha
    bf.SourceConstantAlpha = 255    ' use constant alpha, with

    CALL AlphaBlend(hDcDest, xDest, yDest, wDest, hDest, hDcSrce, xSrce, ySrce, wSrce, hSrce, bf)

END SUB

SUB SetImage(BYVAL hWnd AS LONG)
    LOCAL graphics, DesktopDC, hDeskTop, x, y, hIC, hWndDC AS LONG
    LOCAL rw AS RECT
    LOCAL bf AS BLENDFUNCTION
    LOCAL lp, ptSrc AS POINTAPI
    LOCAL lpSize AS SIZEL
      
    CALL GetWindowRect(hWnd, rw)
    lpSize.Cx = rw.nRight - rw.nLeft: lpSize.Cy = rw.nBottom - rw.nTop
    lp.X = rw.nLeft: lp.Y = rw.nTop
   
    '// Draw active frame to new memory DC
    IF ghBmp = 0 THEN
       hIC = zDisplayDC()
       ghMemDC = CreateCompatibleDC(hIC)'DesktopDC)
       ghBmp = zCreateDIBSection(hIC, lpSize.Cx, lpSize.CY, 32)
       CALL SelectObject(ghMemDC, ghBmp)
       CALL DeleteDC(hIC)
    END IF

'   // Draw background
    CALL zGradientPaintDC(ghMemDC, 0, 0, lpSize.Cx, lpSize.CY, RGB(0,0,8), RGB(0,64,92))
   
'   // Draw the OpenGL scene
    CALL DrawTheScene()
    CALL wglMakeCurrent(hGLDC, hGLRC)
    'CALL SwapBuffers(hGLDC) ' // Because we are drawing to DIB we don't need to swap buffers!
    CALL DrawAndSetupAlphaChannel()
'   // Alphablend the OpenGL animation hover the background
    CALL zAlphaBlend(ghMemDC, 0, 0, lpSize.Cx, lpSize.CY, hGLDC, 0, 0, lpSize.Cx, lpSize.CY)
'
'   // Paint the resulting bitmap to the our window

    hWndDC = GetDC(hWnd)
    CALL BitBlt(hWndDC, 0, 0, lpSize.Cx, lpSize.CY, ghMemDC, 0, 0, %SRCCOPY)       
    CALL ReleaseDC(hWnd, hWndDC)

END SUB

SUB DrawSphere()
    LOCAL quadObj AS LONG
    quadObj = gluNewQuadric()                        ' Pointer to the Quadric Object (Return 0 If No Memory))
    IF quadObj THEN
       CALL gluQuadricNormals(quadObj, %GLU_SMOOTH)  ' Create Smooth Normals
       CALL gluQuadricTexture(quadObj, %GL_TRUE)     ' Create Texture Coords
       'CALL gluSphere(quadObj, 1.5, 3, 2)
       CALL gluSphere(quadObj, 0.6, 16, 16)
       CALL gluDeleteQuadric(quadObj)
    END IF
END SUB

SUB DrawTheScene() ' See MSDN documentation for the use of the OpenGL API

    STATIC xrot AS SINGLE, yrot AS SINGLE, zrot AS SINGLE
    
    CALL glClearColor(0.0, 0.0, 0.0, 0.0)
    CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)
    
    CALL glLoadIdentity()
    
    CALL gluPerspective(45.0, 1.0, 1.0, 100.0)

    CALL glTranslatef(0.0, 0.0, -5.0)

    CALL glRotatef(xrot, 1.0, 0.0, 0.0)                             ' Rotate On The X Axis
    CALL glRotatef(yrot, 0.0, 1.0, 0.0)                             ' Rotate On The Y Axis
    CALL glRotatef(zrot, 0.0, 0.0, 1.0)                             ' Rotate On The Z Axis

    CALL glColor4ub(255,255,255,255)

    CALL glBindTexture(%GL_TEXTURE_2D, mt(1).Texture)
    CALL DrawSphere()

    CALL glBindTexture(%GL_TEXTURE_2D, mt(2).Texture)         
    CALL glBegin(%GL_QUADS)
     ' Front Face
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-1.0,-1.0, 1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 1.0,-1.0, 1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 1.0, 1.0, 1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-1.0, 1.0, 1.0) ' Top Left Of The Texture And Quad
     ' Back Face
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f(-1.0,-1.0,-1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f(-1.0, 1.0,-1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f( 1.0, 1.0,-1.0) ' Top Left Of The Texture And Quad
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f( 1.0,-1.0,-1.0) ' Bottom Left Of The Texture And Quad
     ' Top Face
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-1.0, 1.0,-1.0) ' Top Left Of The Texture And Quad
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-1.0, 1.0, 1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 1.0, 1.0, 1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 1.0, 1.0,-1.0) ' Top Right Of The Texture And Quad
     ' Bottom Face
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f(-1.0,-1.0,-1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f( 1.0,-1.0,-1.0) ' Top Left Of The Texture And Quad
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f( 1.0,-1.0, 1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f(-1.0,-1.0, 1.0) ' Bottom Right Of The Texture And Quad
     ' Right face
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f( 1.0,-1.0,-1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f( 1.0, 1.0,-1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f( 1.0, 1.0, 1.0) ' Top Left Of The Texture And Quad
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f( 1.0,-1.0, 1.0) ' Bottom Left Of The Texture And Quad
     ' Left Face
       CALL glTexCoord2f(0.0, 0.0): CALL glVertex3f(-1.0,-1.0,-1.0) ' Bottom Left Of The Texture And Quad
       CALL glTexCoord2f(1.0, 0.0): CALL glVertex3f(-1.0,-1.0, 1.0) ' Bottom Right Of The Texture And Quad
       CALL glTexCoord2f(1.0, 1.0): CALL glVertex3f(-1.0, 1.0, 1.0) ' Top Right Of The Texture And Quad
       CALL glTexCoord2f(0.0, 1.0): CALL glVertex3f(-1.0, 1.0,-1.0) ' Top Left Of The Texture And Quad
    CALL glEnd()

    xrot = xrot + 0.6*5 ' X Axis Rotation
    yrot = yrot + 0.4*5 ' Y Axis Rotation
    zrot = zrot + 0.8*5 ' Z Axis Rotation

END SUB

FUNCTION Rgb2Gray ALIAS "Rgb2Gray" (BYVAL RGBValue AS DWORD) EXPORT AS DWORD
'    #REGISTER NONE

    !XOR ESI, ESI
    !XOR EDX, EDX
    !MOV ECX, RGBValue

  ' Red
    !MOV EAX, 19595
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

  ' Green
    !MOV EAX, 38470
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

  ' Blue
    !MOV EAX, 7471
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

    !SHR ESI, 16
    !MOV EDX, ESI

  ' Put Gray Value to a DWORD (0GGG)
    !XOR EAX, EAX
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL

    !MOV FUNCTION, EAX

END FUNCTION

SUB DrawAndSetupAlphaChannel()
'   // We must do this to be compatible with BitBlt
'   // We compute a fake alpha channel based on color conversion to shade of gray
    LOCAL pBits AS BYTE PTR, bm AS BITMAP, P AS LONG
    CALL GetObject(GetCurrentObject(hGLDC, 7), SIZEOF(bm), bm)
    pBits = bm.bmBits
    FOR P = (bm.bmWidth * bm.bmHeight) TO 1 STEP - 1
        Alpha& = Rgb2Gray(RGB(@pBits[2],@pBits[1],@pBits[0])) AND &H000000FF???
        '@pBits[3] = MIN&(Alpha& * 255, 255)
        IF Alpha& = 0 THEN ' // This is faster than using MIN&
           @pBits[3] = 0
        ELSE
           @pBits[3] = 255 ' // Setup the opacity level
        END IF
        pBits = pBits + 4
    NEXT
END SUB

FUNCTION zSetupPixelFormat(BYVAL hDC AS LONG) AS LONG
    LOCAL pfd AS PIXELFORMATDESCRIPTOR
    LOCAL pixelformat AS LONG
    LOCAL lRet AS LONG

    lRet = %TRUE

    pfd.nSize      = SIZEOF(pfd)
    pfd.nVersion   = 1
    'pfd.dwFlags    = %PFD_DRAW_TO_WINDOW OR %PFD_SUPPORT_OPENGL OR %PFD_DOUBLEBUFFER OR %PFD_SUPPORT_GDI' This is BassBox setup
    pfd.dwFlags    = %PFD_SUPPORT_OPENGL OR %PFD_SUPPORT_GDI
    pfd.iPixelType = %PFD_TYPE_RGBA

    pfd.cColorBits = 32
    pfd.cDepthBits = 32

    pixelformat = ChoosePixelFormat(hDC, pfd)

    IF pixelformat THEN
       IF SetPixelFormat(hDC, pixelformat, pfd) = 0 THEN lRet = %FALSE
    ELSE
       lRet = %FALSE
    END IF

    FUNCTION = lRet
END FUNCTION

FUNCTION CreateGLcontext(BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYREF hGLDC AS LONG, BYREF hGLRC AS LONG) AS LONG
    LOCAL nRet, DesktopDC, hGLBMP AS LONG
    IF nWidth > 0 AND nHeight > 0 THEN
       DesktopDC = GetDC(0)
       hGLDC = CreateCompatibleDC(DesktopDC)
       hGLBMP = zCreateDIBSection(DesktopDC, nWidth, nHeight, 32)
       CALL SelectObject(hGLDC, hGLBMP)
       CALL ReleaseDC(0, DesktopDC)
       IF hGLBMP THEN
          IF zSetupPixelFormat(hGLDC) THEN
            hGLRC = wglCreateContext(hGLDC)
            IF hGLRC THEN
               IF wglMakeCurrent(hGLDC, hGLRC) THEN
   
                  CALL glClearColor(0.0, 0.0, 0.0, 0.0)
                  CALL glClearDepth(1.0)
                  CALL glDepthFunc(%GL_LEQUAL)'LESS)'GREATER)'LEQUAL)'ALWAYS)
                  CALL glEnable(%GL_DEPTH_TEST)
                  CALL glShadeModel(%GL_SMOOTH)

                  CALL glMatrixMode(%GL_PROJECTION)

                  CALL glViewport(0, 0, nWidth, nHeight)

                  CALL glEnable(%GL_TEXTURE_2D)

'                 // Use alphablending
                  CALL glEnable(%GL_BLEND)
                  CALL glBlendFunc(%GL_SRC_ALPHA, %GL_ONE_MINUS_SRC_ALPHA)

                  nRet = -1
                 
               END IF
            END IF
          END IF
       END IF
    END IF
    FUNCTION = nRet
END FUNCTION

SUB DestroyGLresources(BYREF hGLDC AS LONG, BYREF hGLRC AS LONG)
    IF hGLRC THEN
       CALL wglMakeCurrent(hGLDC, 0)
       CALL wglDeleteContext(hGLRC): hGLRC = 0
    END IF
    IF hGLDC THEN
       CALL DeleteObject(GetCurrentObject(hGLDC, %OBJ_BITMAP)) ' Delete the memory bitmap
       CALL DeleteDC(hGLDC): hGLDC = 0
    END IF
END SUB

